=== debian/changelog ===
calico (3.31.0+ds-0kali2) kali-dev; urgency=medium

  [ Arnaud Rebillout ]
  * Drop 'Rules-Requires-Root: no' from d/control

 -- Sophie Brun <sophie@kali.org>  Mon, 27 Oct 2025 16:02:09 +0100

calico (3.31.0+ds-0kali1) kali-dev; urgency=medium

  * New upstream version 3.31.0+ds
  * Refresh patches
  * Do not ignore the directory vendor
  * Update debian/vendor directory
  * Update build
  * Update old fsf address in debian/copyright
  * Update debian/copyright
  * Bump Standards-Version to 4.7.2
  * Include NOTICE

 -- Sophie Brun <sophie@kali.org>  Mon, 27 Oct 2025 15:49:20 +0100
