=== debian/tests/control ===
Test-Command: calicoctl --help
Restrictions: allow-stderr, superficial
