=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%,\
    repacksuffix=+ds,\
    dversionmangle=auto" \
    https://github.com/projectcalico/calico/releases \
    (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@
